import http from '../utils/http';
import global from '../global'

export default class Request {

    constructor() {
        const { _apiJSON, _genBaseUrl } = global;
        this.apiJSON = _apiJSON
        this.genBaseUrl = _genBaseUrl
    }

    do(app, module, method, form, config = {}) {
        const { params, body } = form;
        let url = ''
        try {
            url = this.apiJSON[app].modules[module][method].path;
        } catch (e) {
            // eslint-disable-next-line no-undef
            console.error(`
      request.js =====> api json configure is error
      full path ======> ${app}/${module}/${method}
      `);
        }
        if (config.showLoading) {

        }
        return http.post({
            baseURL: this.genBaseUrl(this.apiJSON[app].domain),
            url,
            params,
            data: body
        }).finally(() => {
        });
    }
}