
import localCache from "./localCache";
import global from '../global'

export const stringifyQuery = (params) => {
    let str = "";
    let i = 0;
    for (let k in params) {
        let q = "";
        if (i === 0) {
            q = "?";
        } else {
            q = "&";
        }
        str = str + q + k + "=" + params[k];
        i++;
    }
    return str;
};

export class Http {
    constructor() {
        this.queue = {};
    }

    post(options) {
        const { baseURL, url, params, data } = options;
        const { _req, _cache } = global;
        if (_req && _req.before) {
            _req.before(options);
        }
        return new Promise((resolve) => {
            uni.request({
                url: baseURL + url + stringifyQuery(params),
                data,
                method: "POST",
                header: Object.assign({
                    'Content-Type': 'application/json',
                }, (() => {
                    const headers = {};
                    if (localCache.tokenGet()) {
                        headers[_cache?.jwtKey] = localCache.tokenGet();
                    }
                    return headers;
                })()),
                success: (res) => {
                    if (_req && _req.after) {
                        _req.after(res);
                    }
                    resolve(res.data);
                }
            });
        })
    }
}

export default new Http();
