import global from '../global'

export const get = (s) => {
  return uni.getStorageSync(s);
};

export const set = (s, v) => {
  uni.setStorageSync(s, v);
};

export const remove = (s) => {
  uni.removeStorageSync(s);
};

export default {
  tokenSet: (s) => {
    const { _cache } = global;
    set(_cache?.tokenKey, s);
  },
  tokenGet: () => {
    const { _cache } = global;
    return get(_cache?.tokenKey);
  },
  tokenRemove: () => {
    const { _cache } = global;
    remove(_cache?.tokenKey);
  },
};
